package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TEXT_ILLUSTRATION_INDEX_SOURCE;
import static w2phtml.office.XMLString.TEXT_INDEX_BODY;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import w2phtml.office.OfficeReader;

public class IllustrationIndexSplitter extends BasicSplitter implements ISplitter{

	public IllustrationIndexSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
	}

	@Override
	public SplitResults Split(Node illustrationIndex) {
		Node parent = illustrationIndex.getParentNode();
		Node illustrationIndexFirstPart = illustrationIndex.cloneNode(false);
		NodeList childs = illustrationIndex.getChildNodes();
		SplitResults results = new SplitResults(false);
		int i = 0;
		while (childs.getLength() > i) {
			Node child = childs.item(i);
			String childName = child.getNodeName();
			if (childName.equals(TEXT_ILLUSTRATION_INDEX_SOURCE)) {
				illustrationIndexFirstPart.appendChild(child.cloneNode(true));
			} else
			if (childName.equals(TEXT_INDEX_BODY)) {
				if(factory.split(child).isDataMoved()) {
					illustrationIndexFirstPart.appendChild(child.getPreviousSibling());
					results.setDataMoved(true);;
				}
			}
			i++;
		}
		if (results.isDataMoved()) {
			parent.insertBefore(illustrationIndexFirstPart, illustrationIndex);
		}
		return results;
	}

}
